package com.ims.eval.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ims.common.utils.StringUtils;
import com.ims.eval.dao.IndicatorMapper;
import com.ims.eval.entity.DataDictionary;
import com.ims.eval.entity.Indicator;
import com.ims.eval.service.IIndicatorService;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author wang
 * @since 2023-02-26
 */
@Service
public class IndicatorServiceImpl extends ServiceImpl<IndicatorMapper, Indicator> implements IIndicatorService {

	@Override
	public IPage<Indicator> list(Integer pageNum, Integer pageSize,String id, String indicatorName, String indicatorCede, String binSection, String binStage, String dept, String company) {

		QueryWrapper<Indicator> qw = new QueryWrapper<>();
		//构造分页构造器
		Page<Indicator> page = new Page<>(pageNum, pageSize);
		if (StringUtils.isNotEmpty(id)) {
			qw.lambda().eq(Indicator::getId, id);
		}

		if (StringUtils.isNotEmpty(indicatorName)) {
			qw.lambda().like(Indicator::getIndicatorName, indicatorName);
		}

		if (StringUtils.isNotEmpty(indicatorCede)) {
			qw.lambda().like(Indicator::getIndicatorCede, indicatorCede);
		}

		if (StringUtils.isNotEmpty(binSection)) {
			qw.lambda().eq(Indicator::getBinSection, binSection);
		}

		if (StringUtils.isNotEmpty(binStage)) {
			qw.lambda().eq(Indicator::getBinStage, binStage);
		}

		if (StringUtils.isNotEmpty(dept)) {
			qw.lambda().eq(Indicator::getDept, dept);
		}

		if (StringUtils.isNotEmpty(company)) {
			qw.lambda().eq(Indicator::getCompany, company);
		}

		qw.lambda().orderByAsc(Indicator::getOrderNum);

		IPage<Indicator>  list = baseMapper.selectPage(page,qw);

		return list;
	}

	@Override
	public boolean saveOrUpdate(Indicator entity) {


		if (null != entity &&  (null == entity.getId() || "".equals(entity.getId().trim()))){
			QueryWrapper<Indicator> qw = new QueryWrapper<>();
			qw.lambda().eq(Indicator::getIndicatorCede, entity.getIndicatorCede());
			List<Indicator> list = baseMapper.selectList(qw);
			if (null !=list && list.size()>0){
				throw  new RuntimeException("当前指标code已存在");
			}
		}

		return super.saveOrUpdate(entity);
	}
}
